/**
* Copyright (c) 2018 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

.nv-scroll {
  display: block;
  height: 100%;
  overflow: hidden;
  position: relative;
  width: 100%;

  //
  // Scrolls
  //

  .nv-scroll-content {
    height: 100%;
    overflow: hidden;
  }

  &.nv-scroll-y {
    .nv-scroll-content {
      overflow-y: scroll;
      padding-right: 26px;
      width: calc(100% + 26px);
    }

    .nv-v-scroll-y {
      @extend .transition-exit;

      background-color: rgba(0, 0, 0, 0.1);
      height: 100%;
      opacity: 0;
      position: absolute;
      right: 0;
      top: 0;
      transition-delay: 2s;
      transition-property: opacity;
      width: 8px;

      .nv-scroll-y-slider {
        @extend .transition-exit;
        background-color: rgba(0, 0, 0, 0.2);
        pointer-events: none;
        position: absolute;
        top: 0;
        transition-property: background-color;
        width: 100%;

        &:hover {
          @extend .transition-entrance;
          background-color: rgba(0, 0, 0, 0.25);
        }
      }
    }
  }

  &.nv-scroll-y-active {
    .nv-v-scroll-y .nv-scroll-y-slider {
      @extend .transition-entrance;
      background-color: rgba(0, 0, 0, 0.3);
      pointer-events: none;
    }
  }

  &.nv-scroll-x-active {
    .nv-v-scroll-x .nv-scroll-x-slider {
      @extend .transition-entrance;
      background-color: rgba(0, 0, 0, 0.3);
      pointer-events: none;
    }
  }

  &.nv-scroll-x {
    .nv-scroll-content {
      height: calc(100% + 26px);
      overflow-x: scroll;
      padding-bottom: 26px;
      padding-right: 26px;
    }

    .nv-v-scroll-x {
      @extend .transition-exit;

      background-color: rgba(0, 0, 0, 0.1);
      bottom: 0;
      height: 8px;
      opacity: 0;
      position: absolute;
      right: 0;
      transition-property: opacity;
      width: 100%;
    }

    .nv-scroll-x-slider {
      @extend .transition-exit;
      background-color: rgba(0, 0, 0, 0.2);
      height: 100%;
      left: 0;
      position: absolute;
      transition-property: background-color;

      &:hover {
        @extend .transition-entrance;
        background-color: rgba(0, 0, 0, 0.25);
      }

      &:active {
        @extend .transition-entrance;
        background-color: rgba(0, 0, 0, 0.3);
      }
    }
  }

  //
  // Scrolls views
  //

  &.overflow-hidden {
    overflow: hidden;
  }

  &.nv-scroll-display {
    .nv-v-scroll-y,
    .nv-v-scroll-x {
      opacity: 1;
      transition-delay: 0s;
    }
  }

  &.overflow-x {
    overflow-y: auto;

    .nv-scroll-content {
      padding-right: 8px;
    }
  }

  &.overflow-auto {
    overflow: auto;
  }

  .nv-scroll-content-container {
    display: inline-block;
    padding-right: 8px;
  }

  &.nv-scroll-active {
    .nv-scroll-content {
      user-select: none;
    }
  }
}
